LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

entity part1 is
	port
	(
			CLOCK_50 : in std_logic;
		   KEY : in STD_LOGIC_VECTOR(0 downto 0);	
			SW  : in STD_LOGIC_VECTOR(9 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6)	
	);
end;


architecture mine of part1 is
   signal A : std_logic_vector(7 downto 0);
   signal clock, resetn, s, s0: std_logic; 	
	type stateType is (S1, S2, S3);
	signal c_state, n_state : stateType;
	signal load_A, done, inc_result, right_sh_A, reset_count : std_logic;
	signal count : std_logic_vector(3 downto 0);
begin

  clock <= CLOCK_50;
  resetn <= KEY(0);
  
  --LEDR(7 downto 0) <= SW(7 downto 0);
  LEDR(3 downto 0) <= count;
  LEDR(7 downto 4) <= "0000";
  LEDR(8) <= '0';
  LEDR(9) <= done;

	-- sync s :
FFA: entity work.FF(behav)
  port map(clock, resetn, SW(9), s0);
FFB: entity work.FF(behav)
  port map(clock, resetn, s0, s);  
  
state_machine0:  
  process (c_state, s)
  begin
    load_A<='0';
	 inc_result<='0';
	 done<='0';
	 right_sh_A<='0';
	 reset_count<='0';
    case c_state is
      when S1 => 
		   reset_count<='1';
			if s='0' then
				load_A<='1';
				--reset_count<='1';
				n_state<=S1;
			else
				n_state<=S2;
			end if;
		when S2 =>
			right_sh_A <='1';
			if A=x"00" then
				n_state<=S3;
			else
				n_state<=S2;
				if A(0)='1' then
					inc_result<='1';
				end if;
			end if;
		when S3 =>
			done<='1';
			if s='0' then
				n_state<=S1;
		   else
				n_state<=S3;
			end if;
	 end case;
  end process;

state_machine1:  
  process (clock, resetn)
  begin
    if resetn='0' then
		 c_state<=S1;
	 elsif rising_edge(clock) then
	    c_state<=n_state;
	 end if;	
  end process;  
  
counter:
	process(clock, resetn)
	begin
		if resetn='0' or reset_count='1' then
			count<=x"0";
		elsif rising_edge(clock) then
			if inc_result='1' then
				count<=count+1;
			end if;
		end if;
	end process;

shiter:
	process(clock, resetn)
	begin
		if resetn='0' then
			A<=x"00";
		elsif rising_edge(clock) then
			if load_A='1' then
				A<=SW(7 downto 0);
			elsif right_sh_A='1' then
				A<='0' & A(7 downto 1);
			end if;
		end if;
	end process;

				
H0: 
   entity work.DisplayDigit PORT MAP (count, HEX0);	
	
	

end architecture;
	
	
	
