LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

entity part2 is
	port
	(
			CLOCK_50 : in std_logic;
		   KEY : in STD_LOGIC_VECTOR(1 downto 0);	
			SW  : in STD_LOGIC_VECTOR(9 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0);
			HEX0 : OUT STD_LOGIC_VECTOR(0 TO 6);	
   		HEX1 : OUT STD_LOGIC_VECTOR(0 TO 6)--;
--			HEX2 : OUT STD_LOGIC_VECTOR(0 TO 6);	
--			HEX3 : OUT STD_LOGIC_VECTOR(0 TO 6);
--			HEX4 : OUT STD_LOGIC_VECTOR(0 TO 6);	
--			HEX5 : OUT STD_LOGIC_VECTOR(0 TO 6)			
	);
end;


architecture mine of part2 is
   constant N : integer := 5;
	subtype IdxRange is integer range -1 to (N-1);
   signal t_addr, addr, low, outAddr : std_logic_vector(N-1 downto 0);
	signal Idx : IdxRange;
   signal clock, resetn, s, s0: std_logic; 	
	type stateType is (StartSt, AddressPrepared, ReadMem, PrepareAddr, Found, NotFound);
	signal c_state, n_state : stateType;
	signal ndone, done, IntReset, ShiftLow, decIdx,setAddrIdx : std_logic;
	signal dataEqualVal, IdxIsM1, dataLessThanVal: std_logic;
	signal data, val : std_logic_vector(7 downto 0);
begin

  clock <= CLOCK_50;--KEY(1); --
  resetn <= KEY(0);
  
  --LEDR(4 downto 0) <= Low;
  --LEDR(3 downto 0) <= "0000";
  --LEDR(7 downto 4) <= "0000";
--  LEDR(2 downto 0) <= "001" when c_state=StartSt else
--							 "010" when c_state=AddressPrepared else
--							 "011" when c_state=ReadMem else
--							 "100" when c_state=PrepareAddr else
--							 "111" when c_state=Found else
--							 "110" when c_state=NotFound;
  
  LEDR(8) <= ndone;
  LEDR(9) <= done;
  

	-- sync s :
FFA: entity work.FF(behav)
  port map(clock, resetn, SW(9), s0);
FFB: entity work.FF(behav)
  port map(clock, resetn, s0, s);  
  
state_machine0:  
  process (c_state, s, addr, low, data)
  begin
	 setAddrIdx<='0';
    done<= '0';
	 ndone<='0';
	 IntReset<='0';
	 ShiftLow<='0';
	 decIdx<='0';
    case c_state is
      when StartSt => 
			if s='0' then
				n_state<=StartSt;
				IntReset<='1';
			else
				n_state<=AddressPrepared;
			end if;
			
		when AddressPrepared =>
			n_state<=ReadMem;
			
		when ReadMem =>
			ShiftLow <= '1';		
			if (dataEqualVal='1') then
				n_state<=Found;
			elsif (IdxIsM1='1') then
				n_state<=NotFound;
			elsif(dataLessThanVal='1') then
				setAddrIdx<='1';
				n_state<= PrepareAddr;
			else
				n_state<= PrepareAddr;
			end if;
		when PrepareAddr =>
			decIdx <= '1';
			n_state<= AddressPrepared;			
		when Found =>
			done<='1';
			if s='1' then
				n_state<=Found;
		   else
				n_state<=StartSt;
			end if;
		when NotFound => 
			ndone<='1';
			if s='1' then
				n_state<=NotFound;
		   else
				n_state<=StartSt;
			end if;			
	 end case;
  end process;

state_machine1:  
  process (clock, resetn)
  begin
    if resetn='0' then
		 c_state<=StartSt;
	 elsif rising_edge(clock) then
	    c_state<=n_state;
	 end if;	
  end process;  
  
data_path:
	process(clock, resetn, SW)
	begin
		if (resetn='0') then
			t_addr<= "01111";
			addr<="00000";	
			Low<="01111";
			val<=SW(7 downto 0);
			Idx<=4;
		elsif rising_edge(clock) then
			if (IntReset='1') then
				t_addr<= "01111";
				addr<="00000";	
				Low<="01111";
				val<=SW(7 downto 0);
				Idx<=4;	
			end if;
			if  setAddrIdx='1' then
				addr(Idx)<='1';
			end if;
			if decIdx='1' then
				Idx<=Idx-1;
				t_addr<=addr+low;
			end if;
			if ShiftLow='1' then
				Low<='0'&Low(4 downto 1);
			end if;
			
		end if;
	end process;
	
dataEqualVal <= '1' when (data=val) else '0';
IdxIsM1 <= '1' when (Idx=-1) else '0';
dataLessThanVal <= '1'when data<val else '0';
outAddr<= t_addr when done='1' else "00000";

				
H0: 
   entity work.DisplayDigit PORT MAP (outAddr(3 downto 0), HEX0);
H1: 
   entity work.DisplayDigit PORT MAP ("000"&outAddr(4), HEX1);
--H2: 
--   entity work.DisplayDigit PORT MAP (data(3 downto 0), HEX2);
--H3: 
--   entity work.DisplayDigit PORT MAP (data(7 downto 4), HEX3);
--H4: 
--   entity work.DisplayDigit PORT MAP (addr(3 downto 0), HEX4);
--H5: 
--   entity work.DisplayDigit PORT MAP ("000"&addr(4), HEX5);	
	
	
mem: entity work.memory_block	
	PORT MAP (t_addr, clock, "00000000", '0', data);
	
	

end architecture;
	
	
	
